;======================================================
; Ms
;WREG = 
;FSR0 = Address
;======================================================
CLEAR:
        clrf    POINC0,ACCE
        dcsz    WREG,F,ACCE
        jmp     CLEAR
        ret  
;======================================================
;k  ( ƻPQƻݭnAP@Bank)
;md1     Qƪ}
;md2     ƪ}
;md3     G}
;mdl1    Qƪ
;mdl2    ƪ
;G׬ mdl1+mdl2
;S_REG,mdl3 Hs
;Cycle (2 byte * 2 byte) = 105
;======================================================
multiply:
        mvf      BSRCN,w,ACCE
        mvf      FSR0H,F,ACCE
        mvf      FSR1H,F,ACCE
        mvff     md3,FSR0L
        mvf      mdl2,w,ACCE       ; s
        addf     mdl1,w,ACCE
        call     clear
        mvff     mdl1,S_REG
    mult_2:    
        mvff     md3,FSR1L
        mvff     md2,FSR0L
        mvff     INDF0,mdl3
        mvff     mdl1,S_REG        
        mvff     md1,FSR0L
        bcf      STATUS,C,ACCE
     mult_1:   
        mvf      mdl3,w,ACCE
        mulf     POINC0,ACCE
        mvf      PRODL,W,ACCE
        addc     POINC1,F,ACCE  
        mvf      PRODH,W,ACCE
        addc     POINC1,F,ACCE
        clrf     WREG,ACCE
        addc     PODEC1,F,ACCE
        dcsz     S_REG,F,ACCE
        jmp      mult_1
        inf      md3,F,ACCE
        inf      md2,F,ACCE
        dcsz     mdl2,F,ACCE
        jmp      mult_2
        ret
;======================================================
;|ˤJk (ƻPQƻݭnAP@Bank)
;md1     Qƪ}
;md2     ƪ}
;md3     Ӫ}
;mdl1    Qƪ
;mdl2    ƪ
;mdl3    Ӫ
;md4     l(̤j = 5)
;S_REG,r_Len Hs
;Cycle (4 byte / 2 byte) = 2209   Max
;======================================================
divide45:
        call     divide
DV45COM:        
        dcf      mdl2,w,ACCE
        addf     md2,w,ACCE
        mvf      FSR0L,F,ACCE
        mvf      mdl2,W,ACCE
        bcf      status,c,acce
     divide45_1:
        rrfc      PODEC0,F,ACCE
        dcsz     WREG,F,ACCE
        jmp      divide45_1
        LDPR     md4,fsr0
        mvff     md2,FSR1L
        mvl       1            ; don't care Wreg   
        rrfc      WREG,F,ACCE  ; for STATUS cann't be set
     divide45_2:   
        mvf      POINC1,W,ACCE
        subc     POINC0,W,ACCE
        dcsz     mdl2,F,ACCE
        jmp      divide45_2
        btss     STATUS,C,ACCE
        ret
        mvff     MD3,FSR0L         
        bcf      STATUS,C,ACCE
        mvl       1            ; don't care Wreg    
        rrfc      WREG,F,ACCE  ; for STATUS cann't be set
     divide45_3:   
        addc     POINC0,F,ACCE
        dcsz     mdl3,F,ACCE
        jmp      divide45_3
        ret
;======================================================
;k    (ƻPQƻݭnAP@Bank)
;md1     Qƪ}
;md2     ƪ}
;md3     Ӫ}
;mdl1    Qƪ
;mdl2    ƪ
;mdl3    Ӫ
;md4     l(̤j = 5)
;S_REG,r_Len Hs
;Cycle (4 byte / 2 byte) = 2179   Max
;======================================================
divide:
        mvf      BSRCN,w,ACCE
        mvf      FSR0H,F,ACCE
        mvf      FSR1H,F,ACCE
        LDPR     MD4,FSR0
        mvl      5
        call     clear
        mvff     MD3,FSR0L           ; clear remainder
        mvf      mdl3,W,ACCE
        call     clear
        mvf      mdl1,w,ACCE
        mull     8
        mvff     PRODL,S_REG    ; 8 * mdl1 --> S_REG
divlopk:
        mvff    MD1,FSR0L
        mvf     mdl1,w,ACCE
        bcf     status,c,ACCE
divide_rlf_md1:
        rlfc    POINC0,F,ACCE
        dcsz    WREG,F,ACCE
        jmp     divide_rlf_md1
        LDPR    MD4,fsr0         ; md4 rotate left
        mvf     mdl2,W,ACCE
divide_rlf_md4:
        rlfc    POINC0,f,ACCE
        dcsz    WREG,F,ACCE
        jmp     divide_rlf_md4
        jc      div_sub_md4
        LDPR     MD4,FSR0
        mvff     MD2,FSR1L
        mvff     mdl2,r_Len
        mvl       1            ; don't care Wreg    
        rrfc      WREG,F,ACCE  ; for STATUS cann't be set
     ;   bsf      STATUS,C,ACCE
  div_rlf_md4_next:        
        mvf      POINC1,W,ACCE
        subc     POINC0,W,ACCE 
        dcsz     r_Len,F,ACCE
        jmp      div_rlf_md4_next
        jnc      divide_nextprog
  div_sub_md4:      
        LDPR     MD4,FSR0
        mvff     MD2,FSR1L
        mvff     mdl2,r_Len
        mvl       1            ; don't care Wreg   
        rrfc      WREG,F,ACCE  ; for STATUS cann't be set
       ; bsf      STATUS,C,ACCE
  div_sub_md4_1:        
        mvf      POINC1,W,ACCE
        subc     POINC0,F,ACCE 
        dcsz     r_Len,F,ACCE
        jmp      div_sub_md4_1
        mvl       1            ; don't care Wreg   
        rrfc      WREG,F,ACCE  ; for STATUS cann't be set
        ;bsf      status,c,ACCE
divide_nextprog:
        mvff    MD3,FSR0L
        mvf     mdl3,W,ACCE
divide_endloop:
        rlfc    POINC0,F,ACCE
        dcsz    WREG,F,ACCE
        jmp     divide_endloop
        dcsz    S_REG,F,ACCE
        jmp     divlopk
        ret

;================================================================
; QiQi (ݭnAP@Bank)
; FSR1L    Qi}
; FSR0L    Qi}
; WREG      
; MD1 , MD2 , r_Len, MDL1, MDL2 Hs
;Cycle (2 byte ) = 1278
;================================================================
htob:
        mvf     r_Len,F,ACCE
       ; mvf     BSRCN,W,ACCE
       ; mvf     FSR0H,F,ACCE
       ; mvf     FSR1H,ACCE
        mvff    FSR0L,MD1
        mvff    FSR1L,MD2
        inf     r_Len,W,ACCE
        call    CLEAR
        mvff    MD1,FSR0L
        mvf     r_Len,W,ACCE
        mull    8
        mvff    PRODL,MDL1        
        BCF     STATUS,C,ACCE
htob_Lp:
        mvf     r_Len,W,ACCE
  htob_fsr1:
        rlfc    POINC1,F,ACCE
        dcsz    WREG,F,ACCE
        jmp     htob_fsr1
        insz     r_Len,W,ACCE
        nop
  htob_fsr0:
        rlfc    POINC0,F,ACCE
        dcsz    WREG,F,ACCE
        jmp     htob_fsr0
        mvff    MD1,FSR0L
        mvff    MD2,FSR1L
        dcsz    MDL1,F,ACCE
        jmp     htob_adj
        ret
htob_adj:
        insz     r_Len,W,ACCE
        nop
        mvf     MDL2,F,ACCE
  htob_adj_lop:
        call    AdjBcd
        inf     FSR0L,F,ACCE
        dcsz    MDL2,F,ACCE
        jmp     htob_adj_lop
        mvff    MD1,FSR0L
        jmp    htob_Lp
;--------
AdjBcd:
	mvl	03h
        addf    INDF0,w,ACCE
        btsz    WREG,3,ACCE
        mvf     INDF0,F,ACCE
	mvl	30h
        addf    INDF0,W,ACCE
        btsz    WREG,7,ACCE
        mvf     INDF0,F,ACCE
	ret

;================================================================
; QiQi  (ݭnAP@Bank)
; FSR1L    Qi}
; FSR0L    Qi}
; WREG      
; MD1 , MD2 , r_Len, MDL1, MDL2 Hs
;Cycle (2 byte ) = 983
;================================================================
btoh:
        mvf     r_Len,F,ACCE
       ; mvf     BSRCN,W,ACCE
       ; mvf     FSR0H,F,ACCE
       ; mvf     FSR1H,ACCE
        dcf     r_Len,w,ACCE
        addf    FSR1L,F,ACCE
        addf    FSR0L,F,ACCE
        mvff    FSR1L,MD2
        mvff    FSR0L,MD1
        mvf     r_Len,W,ACCE
     BtoH_dec:   
        clrf    PODEC0,ACCE
        dcsz    WREG,F,ACCE
        jmp     BtoH_dec
        mvff    MD1,FSR0L
        mvf     r_Len,W,ACCE
        mull    8
        mvff    PRODL,MDL1        
btoh_LP:
        BCF     STATUS,C,ACCE
        mvf     r_Len,W,ACCE
 btoh_LP_fsr1:
        rrfc    PODEC1,F,ACCE
        dcsz    WREG,F,ACCE
        jmp     btoh_LP_fsr1
        mvf     r_Len,W,ACCE
 btoh_Lp_fsr0:
        rrfc    PODEC0,F,ACCE
        dcsz    WREG,F,ACCE
        jmp     btoh_Lp_fsr0
        mvff    md1,FSR0L
        mvff    md2,FSR1L
        dcsz    MDL1,F,ACCE
        jmp     btoh_adj
        ret

btoh_adj:
        mvff    r_Len,MDL2
        mvff    md2,FSR1L
 btoh_adj_lop:
        call    AdjHex
        dcf     FSR1L,F,ACCE
        dcsz    MDL2,F,ACCE
        jmp     btoh_adj_lop
        mvff    md2,FSR1L
        jmp     btoh_LP
;---------
AdjHex:
        mvl     3
        btsz    INDF1,3
        subf    INDF1,f
        mvl     030h
        btsz    INDF1,7
        subf    INDF1,f
        ret

